// lwbuttonpanel.h
//
// Button applet for controlling an lwpath output.
//
//   (C) Copyright 2002-2016 Fred Gleason <fredg@paravelsystems.com>
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as
//   published by the Free Software Foundation; either version 2 of
//   the License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public
//   License along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#ifndef LWBUTTONPANEL_H
#define LWBUTTONPANEL_H

#include <vector>

#include <QSignalMapper>
#include <QPixmap>
#include <QPushButton>
#include <QWidget>

#include "connect_sap.h"
#include "panelconfig.h"

#define LWBUTTONPANEL_USAGE "[options] --panel=<panel1>\n"
#define LWPANELBUTTON_ACTIVE_STYLESHEET "color: #FFFFFF; background-color: #0000FF;"

class MainWidget : public QWidget
{
  Q_OBJECT
 public:
  MainWidget(QWidget *parent=0);
  ~MainWidget();
  QSize sizeHint() const;

 private slots:
  void buttonClickedData(int n);
  void changeConnectionState(bool state);
  void updateInputNames();
  void updateOutputNames();
  void changeOutputCrosspoint(unsigned output,unsigned input);

 protected:
  void resizeEvent(QResizeEvent *e);

 private:
  unsigned panel_quantity;
  unsigned panel_columns;
  unsigned panel_rows;
  QPixmap *panel_saspanels_map;
  ConnectSap *panel_connect;
  QSignalMapper *panel_button_mapper;
  std::vector<QPushButton *> panel_buttons;
  PanelConfig *panel_config;
  unsigned panel_panel_number;
};


#endif  // LWBUTTONPANEL_H
