// panelconfig.h
//
// Configuration for LWPath Panel Applets
//
//   (C) Copyright 2016 Fred Gleason <fredg@paravelsystems.com>
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as
//   published by the Free Software Foundation; either version 2 of
//   the License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public
//   License along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#ifndef PANELCONFIG_H
#define PANELCONFIG_H

#include <stdint.h>

#include <vector>

#include <QString>

#define PANEL_CONF_FILE "/etc/lwpanel.conf"

class PanelConfig
{
 public:
  PanelConfig();
  QString serverHostname() const;
  uint16_t serverPort() const;
  QString serverUsername() const;
  QString serverPassword() const;
  unsigned matrixNumber() const;
  unsigned panelQuantity() const;
  unsigned panelOutput(unsigned panel) const;
  QString panelName(unsigned panel) const;
  bool allowSource(unsigned panel,unsigned srcnum) const;
  bool load(const QString &filename);

 private:
  QString conf_server_hostname;
  uint16_t conf_server_port;
  QString conf_server_username;
  QString conf_server_password;
  unsigned conf_matrix_number;
  std::vector<unsigned> conf_outputs;
  std::vector<QString> conf_names;
  std::vector<bool> conf_default_policies;
  std::vector<std::vector<unsigned> > conf_exceptions;
};


#endif  // PANEL_CONFIG_H
