// livewire_audioport.h
//
// LiveWire Audio Port record
//
//   (C) Copyright 2015 Fred Gleason <fredg@paravelsystems.com>
//
//   All Rights Reserved.
//

#ifndef LIVEWIRE_AUDIOPORT_H
#define LIVEWIRE_AUDIOPORT_H

#include <QHostAddress>

class LiveWireAudioport
{
 public:
  LiveWireAudioport(unsigned number,const QHostAddress &addr,unsigned slot);
  LiveWireAudioport();
  unsigned number() const;
  void setNumber(unsigned num);
  QHostAddress hostAddress() const;
  bool setHostAddress(const QString &addr);
  unsigned slotNumber() const;
  void setSlotNumber(unsigned slotnum);
  QHostAddress streamAddress() const;
  void setStreamAddress(const QHostAddress &addr);
  QString name() const;
  void setName(const QString &str);
  QString hostName() const;
  void setHostName(const QString &str);

 private:
  unsigned port_number;
  QHostAddress port_host_address;
  unsigned port_slot_number;
  QHostAddress port_stream_address;
  QString port_name;
  QString port_host_name;
};


#endif  // LIVEWIRE_AUDIOPORT_H
