// livewire_gpio.h
//
// LiveWire GPIO record
//
//   (C) Copyright 2015 Fred Gleason <fredg@paravelsystems.com>
//
//   All Rights Reserved.
//

#ifndef LIVEWIRE_GPIO_H
#define LIVEWIRE_GPIO_H

#include <QHostAddress>
#include <QTimer>

#include <sy/sygpiobundle.h>

class LiveWireGpio
{
 public:
  LiveWireGpio(unsigned number,const QHostAddress &addr,unsigned slot);
  LiveWireGpio();
  ~LiveWireGpio();
  unsigned number() const;
  void setNumber(unsigned num);
  QHostAddress hostAddress() const;
  bool setHostAddress(const QString &addr);
  unsigned slotNumber() const;
  void setSlotNumber(unsigned slotnum);
  QString name() const;
  void setName(const QString &str);
  QString hostName() const;
  void setHostName(const QString &str);
  SyGpioBundle *bundle() const;
  QHostAddress sourceAddress() const;
  int sourceSlot() const;
  void setSourceAddress(const QHostAddress &s_addr,int s_slot);
  QTimer *timer();
  QString savedCode() const;
  void setSavedCode(const QString &code);
  void clearSavedCode();

 private:
  unsigned gpio_number;
  QHostAddress gpio_host_address;
  unsigned gpio_slot_number;
  QString gpio_name;
  QString gpio_host_name;
  SyGpioBundle *gpio_bundle;
  QHostAddress gpio_source_address;
  int gpio_source_slot;
  QTimer *gpio_timer;
  QString gpio_saved_code;
};


#endif  // LIVEWIRE_GPIO_H
