// livewire_node.cpp
//
// LiveWire Output record
//
//   (C) Copyright 2015 Fred Gleason <fredg@paravelsystems.com>
//
//   All Rights Reserved.
//

#include "livewire_node.h"

LiveWireNode::LiveWireNode(unsigned number,const QHostAddress &addr,
			   const QString &devname)
{
  node_number=number;
  node_host_address=addr;
  node_device_name=devname;
  node_connected=false;
}


LiveWireNode::LiveWireNode()
{
  node_number=0;
  node_connected=false;
}


unsigned LiveWireNode::number() const
{
  return node_number;
}


void LiveWireNode::setNumber(unsigned num)
{
  node_number=num;
}


QHostAddress LiveWireNode::hostAddress() const
{
  return node_host_address;
}


bool LiveWireNode::setHostAddress(const QString &addr)
{
  node_host_address=QHostAddress(addr);
  return !node_host_address.isNull();
}


QString LiveWireNode::deviceName() const
{
  return node_device_name;
}


void LiveWireNode::setDeviceName(const QString &str)
{
  node_device_name=str;
}


QString LiveWireNode::hostName() const
{
  return node_host_name;
}


void LiveWireNode::setHostName(const QString &str)
{
  node_host_name=str;
}


QString LiveWireNode::password() const
{
  return node_password;
}


void LiveWireNode::setPassword(const QString &str)
{
  node_password=str;
}


bool LiveWireNode::isOnline() const
{
  return node_online;
}


void LiveWireNode::setOnline(bool state)
{
  node_online=state;
}


bool LiveWireNode::connected() const
{
  return node_connected;
}


void LiveWireNode::makeConnected()
{
  node_connected=true;
}
