// livewire_node.h
//
// LiveWire Output record
//
//   (C) Copyright 2015 Fred Gleason <fredg@paravelsystems.com>
//
//   All Rights Reserved.
//

#ifndef LIVEWIRE_NODE_H
#define LIVEWIRE_NODE_H

#include <QHostAddress>

class LiveWireNode
{
 public:
  LiveWireNode(unsigned number,const QHostAddress &addr,const QString &devname);
  LiveWireNode();
  unsigned number() const;
  void setNumber(unsigned num);
  QHostAddress hostAddress() const;
  bool setHostAddress(const QString &addr);
  QString deviceName() const;
  void setDeviceName(const QString &str);
  QString hostName() const;
  void setHostName(const QString &str);
  QString password() const;
  void setPassword(const QString &str);
  bool isOnline() const;
  void setOnline(bool state);
  bool connected() const;
  void makeConnected();

 private:
  unsigned node_number;
  QHostAddress node_host_address;
  QString node_device_name;
  QString node_host_name;
  QString node_password;
  bool node_online;
  bool node_connected;
};


#endif  // LIVEWIRE_NODE_H
