// livewire_audioport.cpp
//
// LiveWire Output record
//
//   (C) Copyright 2015 Fred Gleason <fredg@paravelsystems.com>
//
//   All Rights Reserved.
//

#include <QObject>

#include "config.h"
#include "livewire_audioport.h"

LiveWireAudioport::LiveWireAudioport(unsigned number,const QHostAddress &addr,
				     unsigned slot)
{
  port_number=number;
  port_host_address=addr;
  port_slot_number=slot;
  port_name=QObject::tr(LWPATH_OFF_LABEL);
  port_host_name=addr.toString();
}


LiveWireAudioport::LiveWireAudioport()
{
  port_number=0;
  port_slot_number=0;
  port_name=QObject::tr(LWPATH_OFF_LABEL);
}


unsigned LiveWireAudioport::number() const
{
  return port_number;
}


void LiveWireAudioport::setNumber(unsigned num)
{
  port_number=num;
}


QHostAddress LiveWireAudioport::hostAddress() const
{
  return port_host_address;
}


bool LiveWireAudioport::setHostAddress(const QString &addr)
{
  port_host_address.setAddress(addr);
  return !port_host_address.isNull();
}


unsigned LiveWireAudioport::slotNumber() const
{
  return port_slot_number;
}


void LiveWireAudioport::setSlotNumber(unsigned slotnum)
{
  port_slot_number=slotnum;
}


QHostAddress LiveWireAudioport::streamAddress() const
{
  return port_stream_address;
}


void LiveWireAudioport::setStreamAddress(const QHostAddress &addr)
{
  port_stream_address=addr;
}


QString LiveWireAudioport::name() const
{
  return port_name;
}


void LiveWireAudioport::setName(const QString &str)
{
  port_name=str;
}


QString LiveWireAudioport::hostName() const
{
  return port_host_name;
}


void LiveWireAudioport::setHostName(const QString &str)
{
  port_host_name=str;
}
