// lwpanel.h
//
// Applet for controlling an lwpath output.
//
//   (C) Copyright 2002-2016 Fred Gleason <fredg@paravelsystems.com>
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as
//   published by the Free Software Foundation; either version 2 of
//   the License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public
//   License along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#ifndef LWPANEL_H
#define LWPANEL_H

#include <vector>

#include <QWidget>
#include <QPixmap>

#include "connect_sap.h"
#include "panelconfig.h"
#include "panelwidget.h"

#define LWPANEL_USAGE "[options] --panel=<panel1> [--panel=<panel2> ..]\n"

class MainWidget : public QWidget
{
  Q_OBJECT
 public:
  MainWidget(QWidget *parent=0);
  ~MainWidget();
  QSize sizeHint() const;
  QSizePolicy sizePolicy() const;

 signals:
  void clockTicked(bool state);

 private slots:
  void tickClock();

 protected:
  void paintEvent(QPaintEvent *e);

 private:
  unsigned panel_quantity;
  unsigned panel_columns;
  unsigned panel_rows;
  bool clock_state;
  QPixmap *panel_saspanels_map;
  ConnectSap *panel_connect;
  std::vector<PanelWidget *> panel_widgets;
  PanelConfig *panel_config;
};


#endif  // LWPANEL_H
