// lwpathd.h
//
// lwpathd(8) routing daemon
//
//   (C) Copyright 2015 Fred Gleason <fredg@paravelsystems.com>
//
//   All Rights Reserved.
//

#ifndef LWPATHD_H
#define LWPATHD_H

#include <stdint.h>

#include <map>
#include <vector>

#include <QObject>

#include <sy/syprofile.h>

#include "matrix.h"
#include "protocol.h"

#define LWPATHD_PID_FILE "/var/run/lwpathd.pid"
#define LWPATHD_USAGE "[options]\n"

class MainObject : public QObject
{
 Q_OBJECT;
 public:
  MainObject(QObject *parent=0);

 private slots:
   void startupCompleteData();

 private:
  void LoadMatrices();
  void LoadProtocols();
  std::vector<Matrix *> path_matrices;
  std::vector<Protocol *> path_protocols;
  SyProfile *path_config;
  bool debug;
};


#endif  // LWPATHD_H
