// protocol_sap.h
//
// Software Authority Protocol
//
//   (C) Copyright 2015 Fred Gleason <fredg@paravelsystems.com>
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License version 2 as
//   published by the Free Software Foundation.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public
//   License along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#ifndef PROTOCOL_SAP_H
#define PROTOCOL_SAP_H

#include "protocol.h"
#include "server_sap.h"

class ProtocolSap : public Protocol
{
 Q_OBJECT;
 public:
 ProtocolSap(std::vector<Matrix *> *matrices,SyProfile *config,
	     QObject *parent=0);

 public slots:
  void setReady(bool state);
  void inputNameChanged(int mid,unsigned input,const QString &name);
  void gpiChanged(int mid,unsigned input,const QString &code);
  void outputNameChanged(int mid,unsigned output,const QString &name);
  void outputCrosspointChanged(int mid,unsigned output,unsigned input);
  void gpoChanged(int mid,unsigned output,const QString &code);

 private slots:
  void sapSendMatrixNamesData(int id);
  void sapSendInputNamesData(int id,unsigned cardnum);
  void sapSendOutputNamesData(int id,unsigned cardnum);
  void sapSetRouteData(int id,unsigned cardnum,unsigned input,unsigned output);
  void sapSendRouteInfoData(int id,unsigned cardnum,unsigned output);
  void sapSendGpiInfoData(int id,unsigned cardnum,int input);
  void sapSendGpoInfoData(int id,unsigned cardnum,int output);
  void sapSetGpiStateData(int id,unsigned cardnum,unsigned input,int msecs,
			  const QString &code);
  void sapSetGpoStateData(int id,unsigned cardnum,unsigned input,int msecs,
			  const QString &code);

 private:
  ServerSap *sap_server;
};


#endif  // PROTOCOL_SAP_H
